# -*- coding: utf-8 -*-
# Warteschlange_Tests.py
'''Das Modul definiert die Tests für einen ADT Warteschlange
mit den Methoden Anstellen(dasObjekt), Aufrufen(), DerNaechsteIst(),
GibLaenge(), IstLeer() und Letzter()'''
        
### ------------- Tests ------------------
import unittest

class TestWarteschlange(unittest.TestCase):

    def setUp(self):
        self.warteschlange = Warteschlange()
    
    def test_Initialisierung(self):
        self.assertTrue(self.warteschlange.IstLeer())
        self.assertEqual(self.warteschlange.GibLaenge(), 0)
        self.assertEqual(self.warteschlange.DerNaechsteIst(), None)
        self.assertEqual(self.warteschlange.Letzter(), None)
        # Problem Aufrufen
        self.assertEqual(self.warteschlange.Aufrufen(), None)

    def test_Aktion(self):
        self.warteschlange.Anstellen('Hund')
        self.assertFalse(self.warteschlange.IstLeer())
        self.assertTrue(self.warteschlange.GibLaenge()==1)
        self.assertEqual(self.warteschlange.DerNaechsteIst(), 'Hund')
        self.assertEqual(self.warteschlange.Letzter(), 'Hund')
        
        self.warteschlange.Anstellen('Katze')
        self.assertFalse(self.warteschlange.IstLeer())
        self.assertTrue(self.warteschlange.GibLaenge()==2)
        self.assertEqual(self.warteschlange.DerNaechsteIst(), 'Hund')
        self.assertEqual(self.warteschlange.Letzter(), 'Katze')
        
        self.warteschlange.Anstellen('Vogel')
        self.assertFalse(self.warteschlange.IstLeer())
        self.assertTrue(self.warteschlange.GibLaenge()==3)
        self.assertEqual(self.warteschlange.DerNaechsteIst(), 'Hund')
        self.assertEqual(self.warteschlange.Letzter(), 'Vogel')
        
        self.assertEqual(self.warteschlange.Aufrufen(), 'Hund')
        self.assertFalse(self.warteschlange.IstLeer())
        self.assertTrue(self.warteschlange.GibLaenge()==2)
        self.assertEqual(self.warteschlange.DerNaechsteIst(), 'Katze')
        self.assertEqual(self.warteschlange.Letzter(), 'Vogel')
        
        self.assertEqual(self.warteschlange.Aufrufen(), 'Katze')
        self.assertFalse(self.warteschlange.IstLeer())
        self.assertTrue(self.warteschlange.GibLaenge()==1)
        self.assertEqual(self.warteschlange.DerNaechsteIst(), 'Vogel')
        self.assertEqual(self.warteschlange.Letzter(), 'Vogel')
        
        self.assertEqual(self.warteschlange.Aufrufen(), 'Vogel')
        self.assertTrue(self.warteschlange.IstLeer())
        self.assertTrue(self.warteschlange.GibLaenge()==0)
        self.assertEqual(self.warteschlange.DerNaechsteIst(), None)
        self.assertEqual(self.warteschlange.Letzter(), None)

        # Problem: Was liefert Aufrufen jetzt?
        self.assertEqual(self.warteschlange.Aufrufen(), None)

    # Der hier definierte Test funktioniert erst nach Einbau der Iteratormethoden
##    def test_Iteration(self):
##        self.warteschlange.Anstellen('Hund')
##        self.warteschlange.Anstellen('Katze')
##        self.warteschlange.Anstellen('Vogel')
##        ausgabe = []
##        for element in self.warteschlange:
##            ausgabe.append(element)
##        self.assertEqual(ausgabe, ['Hund', 'Katze', 'Vogel'])

if __name__ == '__main__':
    unittest.main()
